/*
 *    LocBoostApplet.java
 *    Copyright (C) 2000 Gilad Mishne
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
package weka.applet;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.Vector;
import weka.core.*;
import weka.classifiers.*;
import java.net.URL;
import java.net.MalformedURLException;


public class LocBoostApplet extends Applet 
{
	public void init()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setFont(new Font("SansSerif", Font.PLAIN, 10));
		setSize(800,600);
		add(popup);
		popup.setBackground(new java.awt.Color(255,255,185));
		popup.setForeground(java.awt.Color.blue);
		popup.setBounds(372,420,120,24);
		popup.setVisible(false);
		errorCanvas.setEnabled(false);
		add(errorCanvas);
		add(canvas);
		canvas.setBackground(java.awt.Color.white);
		canvas.setBounds(384,16,400,400);		
		undoB.setLabel("Undo");
		add(undoB);
		undoB.setForeground(java.awt.Color.black);
		undoB.setFont(new Font("SansSerif", Font.BOLD, 10));
		undoB.setBounds(300,120,48,24);
		errorCanvas.setForeground(java.awt.Color.lightGray);
		errorCanvas.setBounds(268,504,248,80);
		numOfBlueLabel.setText("0");
		add(numOfBlueLabel);
		numOfBlueLabel.setForeground(java.awt.Color.blue);
		numOfBlueLabel.setFont(new Font("SansSerif", Font.BOLD, 14));
		numOfBlueLabel.setBounds(648,420,50,24);
		numOfRedLabel.setText("0");
		add(numOfRedLabel);
		numOfRedLabel.setForeground(java.awt.Color.red);
		numOfRedLabel.setFont(new Font("SansSerif", Font.BOLD, 14));
		numOfRedLabel.setBounds(732,420,50,24);
		gradientCB.setState(true);
		gradientCB.setLabel("Use gradient colors");
		add(gradientCB);
		gradientCB.setBounds(540,480,132,24);
		msgLabel.setAlignment(java.awt.Label.CENTER);
		add(msgLabel);
		msgLabel.setBackground(java.awt.Color.darkGray);
		msgLabel.setForeground(java.awt.Color.yellow);
		msgLabel.setFont(new Font("Dialog", Font.BOLD, 12));
		msgLabel.setBounds(12,556,200,28);
		panel1.setLayout(null);
		add(panel1);
		panel1.setBackground(java.awt.Color.yellow);
		panel1.setBounds(5,276,370,3);
		panel3.setLayout(null);
		add(panel3);
		panel3.setBackground(java.awt.Color.yellow);
		panel3.setBounds(12,780,603,3);
		label8.setText("Point Editing");
		add(label8);
		label8.setForeground(java.awt.Color.blue);
		label8.setFont(new Font("SansSerif", Font.BOLD, 18));
		label8.setBounds(48,24,169,25);
		label9.setText("Classification");
		add(label9);
		label9.setForeground(java.awt.Color.blue);
		label9.setFont(new Font("SansSerif", Font.BOLD, 18));
		label9.setBounds(48,288,139,25);
		label11.setText("Current Action:");
		add(label11);
		label11.setForeground(java.awt.Color.blue);
		label11.setFont(new Font("SansSerif", Font.BOLD, 12));
		label11.setBounds(26,528,120,24);
		panel4.setLayout(null);
		add(panel4);
		panel4.setBackground(java.awt.Color.yellow);
		panel4.setBounds(5,10,3,584);
		label12.setText("Number of Points:");
		add(label12);
		label12.setForeground(java.awt.Color.black);
		label12.setFont(new Font("SansSerif", Font.BOLD, 12));
		label12.setBounds(504,420,108,24);
		panel6.setLayout(null);
		add(panel6);
		panel6.setBackground(java.awt.Color.yellow);
		panel6.setBounds(792,10,3,584);
		panel2.setLayout(null);
		add(panel2);
		panel2.setBackground(java.awt.Color.yellow);
		panel2.setBounds(5,10,790,3);
		panel5.setLayout(null);
		add(panel5);
		panel5.setBackground(java.awt.Color.yellow);
		panel5.setBounds(372,10,3,480);
		label6.setText("Decision Boundary smoothness (1-100)");
		add(label6);
		label6.setFont(new Font("SansSerif", Font.PLAIN, 10));
		label6.setBounds(540,456,192,24);
		smoothnessTF.setText("10");
		add(smoothnessTF);
		smoothnessTF.setFont(new Font("SansSerif", Font.PLAIN, 10));
		smoothnessTF.setBounds(732,456,35,24);
		label18.setText("Base:");
		add(label18);
		label18.setFont(new Font("SansSerif", Font.PLAIN, 10));
		label18.setBounds(36,360,48,24);
		smoothingCB.setLabel("Use boundary smoothing");
		add(smoothingCB);
		smoothingCB.setFont(new Font("SansSerif", Font.PLAIN, 10));
		smoothingCB.setBounds(540,528,156,24);
		refreshB.setLabel("Refresh");
		add(refreshB);
		refreshB.setFont(new Font("SansSerif", Font.BOLD, 10));
		refreshB.setBounds(696,528,84,36);
		panel7.setLayout(null);
		add(panel7);
		panel7.setBackground(java.awt.Color.yellow);
		panel7.setBounds(372,444,420,3);
		panel8.setLayout(null);
		add(panel8);
		panel8.setBackground(java.awt.Color.yellow);
		panel8.setBounds(5,592,790,3);
		helpB.setLabel("Help...");
		add(helpB);
		helpB.setFont(new Font("SansSerif", Font.PLAIN, 10));
		helpB.setBounds(276,24,84,36);
		panel10.setLayout(null);
		add(panel10);
		panel10.setBackground(java.awt.Color.yellow);
		panel10.setBounds(528,444,2,150);
		pB.setLabel("Stop Drawing");
		add(pB);
		pB.setFont(new Font("SansSerif", Font.PLAIN, 10));
		pB.setBounds(696,492,82,36);
		pB.setVisible(false);
		label14.setText("1.0");
		add(label14);
		label14.setFont(new Font("SansSerif", Font.PLAIN, 10));
		label14.setBounds(240,498,24,24);
		label15.setText("0.0");
		add(label15);
		label15.setFont(new Font("SansSerif", Font.PLAIN, 10));
		label15.setBounds(240,564,24,24);
		label16.setText("0.5");
		add(label16);
		label16.setFont(new Font("SansSerif", Font.PLAIN, 10));
		label16.setBounds(240,528,24,27);
		labeTestlErr.setAlignment(java.awt.Label.CENTER);
		add(labeTestlErr);
		labeTestlErr.setForeground(new java.awt.Color(0,128,0));
		labeTestlErr.setFont(new Font("SansSerif", Font.BOLD, 12));
		labeTestlErr.setBounds(468,450,36,24);
		panel13.setLayout(null);
		add(panel13);
		panel13.setBackground(java.awt.Color.yellow);
		panel13.setBounds(252,12,2,72);
		instApprCB.setState(true);
		instApprCB.setLabel("Large Points");
		add(instApprCB);
		instApprCB.setBounds(540,504,132,24);
		label10.setText("Test Error:");
		add(label10);
		label10.setForeground(new java.awt.Color(0,128,0));
		label10.setFont(new Font("SansSerif", Font.BOLD, 12));
		label10.setBounds(384,450,60,24);
		labelTrainErr.setAlignment(java.awt.Label.CENTER);
		add(labelTrainErr);
		labelTrainErr.setForeground(new java.awt.Color(128,0,255));
		labelTrainErr.setFont(new Font("SansSerif", Font.BOLD, 12));
		labelTrainErr.setBounds(468,472,36,24);
		label17.setText("Train Error:");
		add(distribChoice);
		add(label17);
		label17.setForeground(new java.awt.Color(128,0,255));
		label17.setFont(new Font("SansSerif", Font.BOLD, 12));
		label17.setBounds(384,472,72,24);
		labelIter.setAlignment(java.awt.Label.CENTER);
		add(labelIter);
		labelIter.setBackground(java.awt.Color.darkGray);
		labelIter.setForeground(java.awt.Color.green);
		labelIter.setFont(new Font("Dialog", Font.BOLD, 12));
		labelIter.setBounds(132,495,36,24);
		inLabel.setText("Iteration Number");
		add(inLabel);
		inLabel.setForeground(java.awt.Color.blue);
		inLabel.setFont(new Font("SansSerif", Font.BOLD, 12));
		inLabel.setBounds(24,495,104,24);
		reportB.setLabel("Generate Report ...");
		add(reportB);
		reportB.setFont(new Font("SansSerif", Font.PLAIN, 10));
		reportB.setBounds(240,288,120,24);
		label5.setText("Add single points");
		add(label5);
		label5.setFont(new Font("SansSerif", Font.PLAIN, 10));
		label5.setBounds(60,60,144,24);
		singleRB.setCheckboxGroup(Group1);
		add(singleRB);
		singleRB.setBounds(24,60,132,24);
		multipleRB.setCheckboxGroup(Group1);
		multipleRB.setState(true);
		add(multipleRB);
		multipleRB.setBounds(24,84,36,24);
		numTF.setText("50");
		add(numTF);
		numTF.setFont(new Font("SansSerif", Font.PLAIN, 10));
		numTF.setBounds(96,84,36,26);
		label2.setText("points, using");
		add(label2);
		label2.setFont(new Font("SansSerif", Font.PLAIN, 10));
		label2.setBounds(144,84,76,28);
		distribChoice.addItem("Normal");
		distribChoice.addItem("Uniform");
		try {
			distribChoice.select(0);
		}
		catch (IllegalArgumentException e) { }
		distribChoice.setBackground(java.awt.Color.white);
		distribChoice.setBounds(216,84,70,23);
		coverL.setText("Covering");
		add(coverL);
		coverL.setForeground(java.awt.Color.black);
		coverL.setFont(new Font("SansSerif", Font.PLAIN, 10));
		coverL.setBounds(60,120,55,25);
		coverL.setVisible(false);
		coverTF.setText("100");
		add(coverTF);
		coverTF.setForeground(java.awt.Color.black);
		coverTF.setFont(new Font("SansSerif", Font.PLAIN, 10));
		coverTF.setBounds(120,120,30,25);
		coverTF.setVisible(false);
		percentL.setText("% of the area");
		add(percentL);
		percentL.setForeground(java.awt.Color.black);
		percentL.setFont(new Font("SansSerif", Font.PLAIN, 10));
		percentL.setBounds(156,120,75,29);
		percentL.setVisible(false);
		label3.setText("% of the data for training");
		add(label3);
		label3.setFont(new Font("SansSerif", Font.PLAIN, 10));
		label3.setBounds(84,156,160,24);
		dataPercentTF.setText("75");
		add(dataPercentTF);
		dataPercentTF.setFont(new Font("SansSerif", Font.PLAIN, 10));
		dataPercentTF.setBounds(48,156,35,20);
		label1.setText("Use");
		add(label1);
		label1.setFont(new Font("SansSerif", Font.PLAIN, 10));
		label1.setBounds(24,156,25,24);
		clearB.setLabel("Clear All Points");
		add(clearB);
		clearB.setForeground(java.awt.Color.blue);
		clearB.setFont(new Font("SansSerif", Font.BOLD, 10));
		clearB.setBounds(84,204,204,24);
		loadB.setLabel("Load ...");
		add(loadB);
		loadB.setForeground(java.awt.Color.black);
		loadB.setFont(new Font("SansSerif", Font.BOLD, 10));
		loadB.setBounds(24,240,84,24);
		saveB.setLabel("Save ...");
		add(saveB);
		saveB.setForeground(java.awt.Color.black);
		saveB.setFont(new Font("SansSerif", Font.BOLD, 10));
		saveB.setBounds(120,240,84,24);
		viewArffB.setLabel("View arff file ...");
		add(viewArffB);
		viewArffB.setFont(new Font("SansSerif", Font.PLAIN, 10));
		viewArffB.setBounds(228,240,120,24);
		label4.setText("Add:");
		add(label4);
		label4.setFont(new Font("SansSerif", Font.PLAIN, 10));
		label4.setBounds(60,84,36,24);
		label7.setText("Distribution");
		add(label7);
		label7.setFont(new Font("SansSerif", Font.PLAIN, 10));
		label7.setBounds(300,84,72,24);
		sigmaL.setText("Sigma:");
		add(sigmaL);
		sigmaL.setFont(new Font("SansSerif", Font.PLAIN, 10));
		sigmaL.setBounds(96,120,40,25);
		sigmaTF.setText("1");
		add(sigmaTF);
		sigmaTF.setFont(new Font("SansSerif", Font.PLAIN, 10));
		sigmaTF.setBounds(144,120,30,25);
		splitB.setLabel("Split Now");
		add(splitB);
		splitB.setFont(new Font("SansSerif", Font.PLAIN, 10));
		splitB.setBounds(264,156,84,24);
		step.setLabel("Iterate once");
		add(step);
		step.setForeground(java.awt.Color.blue);
		step.setFont(new Font("SansSerif", Font.PLAIN, 10));
		step.setBounds(24,432,108,42);
		genCB1.setState(true);
		genCB1.setLabel("Optimize parameters using");
		add(genCB1);
		genCB1.setFont(new Font("SansSerif", Font.PLAIN, 10));
		genCB1.setBounds(24,396,156,24);
		labelKernel.setText("Complexity:");
		add(labelKernel);
		labelKernel.setFont(new Font("SansSerif", Font.PLAIN, 10));
		labelKernel.setBounds(72,372,96,24);
		labelKernel.setVisible(false);
		labelCF.setText("Confidence Factor:");
		add(labelCF);
		labelCF.setFont(new Font("SansSerif", Font.PLAIN, 10));
		labelCF.setBounds(48,360,116,24);
		labelCF.setVisible(false);
		label13.setText("Classifier:");
		add(label13);
		label13.setFont(new Font("SansSerif", Font.PLAIN, 10));
		label13.setBounds(24,324,60,24);
		classifierChoice.addItem("AdaBoost");
		classifierChoice.addItem("Bagging");
		classifierChoice.addItem("C4.5 Decision Tree");
		classifierChoice.addItem("Decision Stump");
		classifierChoice.addItem("Decision Table");
		classifierChoice.addItem("K-Nearest Neighbor");
		classifierChoice.addItem("LocBoost");
		classifierChoice.addItem("LocBoost/Logistic");
		classifierChoice.addItem("Logistic");
		classifierChoice.addItem("LogitBoost");
		classifierChoice.addItem("Naive Bayes");
		classifierChoice.addItem("Regression");
		classifierChoice.addItem("SVM (SMO)");
		classifierChoice.addItem("SVM (Kernel Density)");
		try {
			classifierChoice.select(6);
		}
		catch (IllegalArgumentException e) { }
		classifierChoice.setBackground(java.awt.Color.white);
		classifierChoice.setForeground(new java.awt.Color(163,1,17));
		add(classifierChoice);
		classifierChoice.setBounds(84,324,168,23);
		baseChoice.addItem("C4.5 Tree");
		baseChoice.addItem("Decision Stump");
		baseChoice.addItem("Decision Table");
		baseChoice.addItem("1-Nearest Neighbor");
		baseChoice.addItem("Logistic");
		baseChoice.addItem("Naive Bayes");
		baseChoice.addItem("Voted Perceptron");
		baseChoice.addItem("ZeroR");
		try {
			baseChoice.select(4);
		}
		catch (IllegalArgumentException e) { }
		baseChoice.setBackground(java.awt.Color.white);
		baseChoice.setForeground(java.awt.Color.black);
		add(baseChoice);
		baseChoice.setBounds(108,360,124,23);
		labelAda.setText("Number of iterations:");
		add(labelAda);
		labelAda.setFont(new Font("SansSerif", Font.PLAIN, 10));
		labelAda.setBounds(72,396,96,24);
		labelAda.setVisible(false);
		labelKNN.setText("Neighbors");
		add(labelKNN);
		labelKNN.setFont(new Font("SansSerif", Font.PLAIN, 10));
		labelKNN.setBounds(72,372,96,24);
		labelKNN.setVisible(false);
		optimTF.setText("3");
		add(optimTF);
		optimTF.setFont(new Font("SansSerif", Font.PLAIN, 10));
		optimTF.setBounds(180,396,35,20);
		kernelTF.setText("2");
		add(kernelTF);
		kernelTF.setFont(new Font("SansSerif", Font.PLAIN, 10));
		kernelTF.setBounds(168,396,35,20);
		kernelTF.setVisible(false);
		KNNTF.setText("2");
		add(KNNTF);
		KNNTF.setFont(new Font("SansSerif", Font.PLAIN, 10));
		KNNTF.setBounds(168,372,35,20);
		KNNTF.setVisible(false);
		complexTF.setText("1000");
		add(complexTF);
		complexTF.setFont(new Font("SansSerif", Font.PLAIN, 10));
		complexTF.setBounds(168,372,55,20);
		complexTF.setVisible(false);
		nfTF.setText("3");
		add(nfTF);
		nfTF.setFont(new Font("SansSerif", Font.PLAIN, 10));
		nfTF.setBounds(168,396,55,20);
		nfTF.setVisible(false);
		classifyB.setLabel("Classify");
		add(classifyB);
		classifyB.setForeground(java.awt.Color.blue);
		classifyB.setFont(new Font("SansSerif", Font.PLAIN, 10));
		classifyB.setBounds(24,432,108,42);
		resetB.setLabel("Reset");
		add(resetB);
		resetB.setForeground(new java.awt.Color(0,128,128));
		resetB.setFont(new Font("SansSerif", Font.PLAIN, 10));
		resetB.setBounds(288,432,72,42);
		adaIterTF.setText("50");
		add(adaIterTF);
		adaIterTF.setFont(new Font("SansSerif", Font.PLAIN, 10));
		adaIterTF.setBounds(180,396,35,20);
		adaIterTF.setVisible(false);
		labelC.setText("Kernel Degree:");
		add(labelC);
		labelC.setFont(new Font("SansSerif", Font.PLAIN, 10));
		labelC.setBounds(72,396,96,24);
		labelC.setVisible(false);
		cfTF.setText("0.25");
		add(cfTF);
		cfTF.setFont(new Font("SansSerif", Font.PLAIN, 10));
		cfTF.setBounds(168,360,55,20);
		cfTF.setVisible(false);
		genCB2.setLabel("Use regularization");
		add(genCB2);
		genCB2.setFont(new Font("SansSerif", Font.PLAIN, 10));
		genCB2.setBounds(256,324,120,21);
		label19.setText("optimization steps");
		add(label19);
		label19.setFont(new Font("SansSerif", Font.PLAIN, 10));
		label19.setBounds(228,396,84,24);
		panel9.setLayout(null);
		add(panel9);
		panel9.setBackground(java.awt.Color.yellow);
		panel9.setBounds(6,488,366,3);
		numIterTF.setText("3");
		add(numIterTF);
		numIterTF.setForeground(java.awt.Color.blue);
		numIterTF.setFont(new Font("SansSerif", Font.PLAIN, 10));
		numIterTF.setBounds(194,442,24,24);
		stepN.setLabel("Iterate             times");
		add(stepN);
		stepN.setForeground(java.awt.Color.blue);
		stepN.setFont(new Font("SansSerif", Font.PLAIN, 10));
		stepN.setBounds(144,432,120,42);
		labelNF.setText("Number of Folds:");
		add(labelNF);
		labelNF.setFont(new Font("SansSerif", Font.PLAIN, 10));
		labelNF.setBounds(60,396,116,24);
		labelNF.setVisible(false);
		pruneCB.setLabel("Don\'t prune tree");
		add(pruneCB);
		pruneCB.setFont(new Font("SansSerif", Font.PLAIN, 10));
		pruneCB.setBounds(252,360,108,24);
		pruneCB.setVisible(false);
		pruneCB.setState(true);
		//}}
        ((LocBoost)myClassifier).setMaxIterations(0);

		//{{REGISTER_LISTENERS
		MItemListener lmyItem = new MItemListener();
		MTextListener lmyText = new MTextListener();
		MActionListener lmyAction = new MActionListener();
		distribChoice.addItemListener(lmyItem);
		classifierChoice.addItemListener(lmyItem);
		baseChoice.addItemListener(lmyItem);
		clearB.addActionListener(lmyAction);
		classifyB.addActionListener(lmyAction);
		viewArffB.addActionListener(lmyAction);
		reportB.addActionListener(lmyAction);
		singleRB.addItemListener(lmyItem);
		multipleRB.addItemListener(lmyItem);
		refreshB.addActionListener(lmyAction);
		gradientCB.addItemListener(lmyItem);
		instApprCB.addItemListener(lmyItem);
		dataPercentTF.addTextListener(lmyText);
		splitB.addActionListener(lmyAction);
		helpB.addActionListener(lmyAction);
		undoB.addActionListener(lmyAction);
		saveB.addActionListener(lmyAction);
		loadB.addActionListener(lmyAction);
		step.addActionListener(lmyAction);
		stepN.addActionListener(lmyAction);
		resetB.addActionListener(lmyAction);
		pB.addActionListener(lmyAction);
		genCB1.addItemListener(lmyItem);
		genCB2.addItemListener(lmyItem);
		MMouse lMouse = new MMouse();
		helpB.addMouseListener(lMouse);
		classifierChoice.addMouseListener(lMouse);
		baseChoice.addMouseListener(lMouse);
		clearB.addMouseListener(lMouse);
		classifyB.addMouseListener(lMouse);
		viewArffB.addMouseListener(lMouse);
		reportB.addMouseListener(lMouse);
		refreshB.addMouseListener(lMouse);
		gradientCB.addMouseListener(lMouse);
		instApprCB.addMouseListener(lMouse);
		splitB.addMouseListener(lMouse);
		undoB.addMouseListener(lMouse);
		saveB.addMouseListener(lMouse);
		loadB.addMouseListener(lMouse);
		step.addMouseListener(lMouse);
		stepN.addMouseListener(lMouse);
		resetB.addMouseListener(lMouse);
		smoothingCB.addMouseListener(lMouse);
		MMouseMotion lMouseMotion = new MMouseMotion();
		helpB.addMouseMotionListener(lMouseMotion);
		classifierChoice.addMouseMotionListener(lMouseMotion);
		baseChoice.addMouseMotionListener(lMouseMotion);
		clearB.addMouseMotionListener(lMouseMotion);
		classifyB.addMouseMotionListener(lMouseMotion);
		viewArffB.addMouseMotionListener(lMouseMotion);
		reportB.addMouseMotionListener(lMouseMotion);
		refreshB.addMouseMotionListener(lMouseMotion);
		gradientCB.addMouseMotionListener(lMouseMotion);
		instApprCB.addMouseMotionListener(lMouseMotion);
		splitB.addMouseMotionListener(lMouseMotion);
		undoB.addMouseMotionListener(lMouseMotion);
		saveB.addMouseMotionListener(lMouseMotion);
		loadB.addMouseMotionListener(lMouseMotion);
		step.addMouseMotionListener(lMouseMotion);
		stepN.addMouseMotionListener(lMouseMotion);
		resetB.addMouseMotionListener(lMouseMotion);
		smoothingCB.addMouseMotionListener(lMouseMotion);
		//}}

	}
	
	//{{DECLARE_CONTROLS
	java.awt.Canvas popup = new java.awt.Canvas();
	java.awt.Canvas errorCanvas = new java.awt.Canvas();
	//java.awt.Canvas canvas = new java.awt.Canvas();
	java.awt.Button undoB = new java.awt.Button();
	java.awt.Label numOfBlueLabel = new java.awt.Label();
	java.awt.Label numOfRedLabel = new java.awt.Label();
	java.awt.Checkbox gradientCB = new java.awt.Checkbox();
	java.awt.Label msgLabel = new java.awt.Label();
	java.awt.Panel panel1 = new java.awt.Panel();
	java.awt.Panel panel3 = new java.awt.Panel();
	java.awt.Label label8 = new java.awt.Label();
	java.awt.Label label9 = new java.awt.Label();
	java.awt.Label label11 = new java.awt.Label();
	java.awt.Panel panel4 = new java.awt.Panel();
	java.awt.Label label12 = new java.awt.Label();
	java.awt.Panel panel6 = new java.awt.Panel();
	java.awt.Panel panel2 = new java.awt.Panel();
	java.awt.Panel panel5 = new java.awt.Panel();
	java.awt.Label label6 = new java.awt.Label();
	java.awt.TextField smoothnessTF = new java.awt.TextField();
	java.awt.Label label18 = new java.awt.Label();
	java.awt.Checkbox smoothingCB = new java.awt.Checkbox();
	java.awt.Button refreshB = new java.awt.Button();
	java.awt.Panel panel7 = new java.awt.Panel();
	java.awt.Panel panel8 = new java.awt.Panel();
	java.awt.Button helpB = new java.awt.Button();
	java.awt.Panel panel10 = new java.awt.Panel();
	java.awt.Button pB = new java.awt.Button();
	java.awt.Label label14 = new java.awt.Label();
	java.awt.Label label15 = new java.awt.Label();
	java.awt.Label label16 = new java.awt.Label();
	java.awt.Label labeTestlErr = new java.awt.Label();
	java.awt.Panel panel13 = new java.awt.Panel();
	java.awt.Checkbox instApprCB = new java.awt.Checkbox();
	java.awt.Label label10 = new java.awt.Label();
	java.awt.Label labelTrainErr = new java.awt.Label();
	java.awt.Label label17 = new java.awt.Label();
	java.awt.Label labelIter = new java.awt.Label();
	java.awt.Label inLabel = new java.awt.Label();
	java.awt.Button reportB = new java.awt.Button();
	java.awt.Label label5 = new java.awt.Label();
	java.awt.Checkbox singleRB = new java.awt.Checkbox();
	java.awt.CheckboxGroup Group1 = new java.awt.CheckboxGroup();
	java.awt.Checkbox multipleRB = new java.awt.Checkbox();
	java.awt.TextField numTF = new java.awt.TextField();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.Choice distribChoice = new java.awt.Choice();
	java.awt.Label coverL = new java.awt.Label();
	java.awt.TextField coverTF = new java.awt.TextField();
	java.awt.Label percentL = new java.awt.Label();
	java.awt.Label label3 = new java.awt.Label();
	java.awt.TextField dataPercentTF = new java.awt.TextField();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Button clearB = new java.awt.Button();
	java.awt.Button loadB = new java.awt.Button();
	java.awt.Button saveB = new java.awt.Button();
	java.awt.Button viewArffB = new java.awt.Button();
	java.awt.Label label4 = new java.awt.Label();
	java.awt.Label label7 = new java.awt.Label();
	java.awt.Label sigmaL = new java.awt.Label();
	java.awt.TextField sigmaTF = new java.awt.TextField();
	java.awt.Button splitB = new java.awt.Button();
	java.awt.Button step = new java.awt.Button();
	java.awt.Checkbox genCB1 = new java.awt.Checkbox();
	java.awt.Label labelKernel = new java.awt.Label();
	java.awt.Label labelCF = new java.awt.Label();
	java.awt.Label label13 = new java.awt.Label();
	java.awt.Choice classifierChoice = new java.awt.Choice();
	java.awt.Choice baseChoice = new java.awt.Choice();
	java.awt.Label labelAda = new java.awt.Label();
	java.awt.Label labelKNN = new java.awt.Label();
	java.awt.TextField optimTF = new java.awt.TextField();
	java.awt.TextField kernelTF = new java.awt.TextField();
	java.awt.TextField KNNTF = new java.awt.TextField();
	java.awt.TextField complexTF = new java.awt.TextField();
	java.awt.TextField nfTF = new java.awt.TextField();
	java.awt.Button classifyB = new java.awt.Button();
	java.awt.Button resetB = new java.awt.Button();
	java.awt.TextField adaIterTF = new java.awt.TextField();
	java.awt.Label labelC = new java.awt.Label();
	java.awt.TextField cfTF = new java.awt.TextField();
	java.awt.Checkbox genCB2 = new java.awt.Checkbox();
	java.awt.Label label19 = new java.awt.Label();
	java.awt.Panel panel9 = new java.awt.Panel();
	java.awt.TextField numIterTF = new java.awt.TextField();
	java.awt.Button stepN = new java.awt.Button();
	java.awt.Label labelNF = new java.awt.Label();
	java.awt.Checkbox pruneCB = new java.awt.Checkbox();
	//}}
	DrawCanvas canvas = new DrawCanvas(numTF, numOfBlueLabel, numOfRedLabel, this);
    Classifier myWeakClassifier = null;
    Classifier myBooster;
    Vector errVec = new Vector();
    Classifier myClassifier = new LocBoost();
    boolean drawThr_suspended = false;
    boolean boosterStarted = false;
    boolean showToolTip = false;
    ToolTipThread toolTipThr = new ToolTipThread();
    int toolTipCount = 0;
    Point prevErr = new Point(2,0);
    
	class MItemListener implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == genCB1) {
	            if (myClassifier instanceof LocBoost)
				    ((LocBoost)myClassifier).setOptimization(genCB1.getState());
				else
				    ((LocBoost2)myClassifier).setOptimization(genCB1.getState());
				optimTF.setVisible(genCB1.getState());
				label19.setVisible(genCB1.getState());
				if (genCB1.getState()) 
				    genCB1.setLabel("Optimize parameters using");
				else
    				genCB1.setLabel("Optimize parameters");
			}
			else if (object == genCB2)
	            if (myClassifier instanceof LocBoost)
				    ((LocBoost)myClassifier).setOverfitting(genCB2.getState());
				else
				    ((LocBoost2)myClassifier).setOverfitting(genCB2.getState());
			else if (object == classifierChoice)
				classifierChoice_ItemStateChanged();
			else if (object == baseChoice)
				baseChoice_ItemStateChanged();
			else if (object == multipleRB)
				multipleRB_ItemStateChanged();
			else if ((object == gradientCB) || (object == instApprCB)) {
			    canvas.DrawAllFlag = true;
				canvas.repaint();
			}
			else if (object == distribChoice)
				distribChoice_ItemStateChanged();
			else if (object == singleRB)
				singleRB_ItemStateChanged();
		}
	}

	void classifierChoice_ItemStateChanged()
	{
        initCanvas();
        selectClassifier(classifierChoice.getSelectedIndex());
 	    setClassifierGUI();
    }

	void baseChoice_ItemStateChanged()
	{
	    DistributionClassifier base = null;
	    int type = baseChoice.getSelectedIndex();
        if (myClassifier instanceof LogitBoost) {
	        switch (type) {
	            case 0: base = new DecisionStump(); break;
	            case 1: base = new DecisionTable(); break;
	        }
        } else {
	        switch (type) {
	            case 0: base = new weka.classifiers.j48.J48(); break;	        
	            case 1: base = new DecisionStump(); break;
	            case 2: base = new DecisionTable(); break;
	            case 3: base = new IBk(1); break;	        
	            case 4: base = new Logistic(); break;
	            case 5: base = new NaiveBayes(); break;
	            case 6: base = new VotedPerceptron(); break;	        
	            case 7: base = new ZeroR(); break;
	        }
	    }
	    if (myClassifier instanceof AdaBoostM1)
	        ((AdaBoostM1)myClassifier).setClassifier(base);
	    else if (myClassifier instanceof LocBoost)
	        ((LocBoost)myClassifier).setBaseClassifier(type);
	    else if (myClassifier instanceof Bagging)
	        ((Bagging)myClassifier).setClassifier(base);
	    else if (myClassifier instanceof ClassificationViaRegression)
	        ((ClassificationViaRegression)myClassifier).setClassifier(base);
	    else if (myClassifier instanceof LogitBoost)
	        ((LogitBoost)myClassifier).setClassifier(base);
    }

    void updateErrGraph() {
        initCanvas();
        double trainErrRate = 0;
        double testErrRate = 0;
        try {
	        testErrRate = 1.0 - myClassifier.evaluateErr(canvas.testInstances);
	        trainErrRate = 1.0 - myClassifier.evaluateErr(canvas.trainInstances);
        } catch (Exception e) { e.printStackTrace(); }   
        String trerr = trainErrRate==0.0?"0.0":String.valueOf( 0.001*(Math.rint(1000*trainErrRate)) );
        String tserr = testErrRate== 0.0?"0.0":String.valueOf( 0.001*(Math.rint(1000*testErrRate)) );
        labeTestlErr.setText (tserr.substring(0, tserr.length()>5?5:tserr.length()));
        labelTrainErr.setText(trerr.substring(0, trerr.length()>5?5:trerr.length()));
        if (myClassifier instanceof LocBoost || myClassifier instanceof LocBoost2) {
            Rectangle r = errorCanvas.getBounds();        
            Graphics g = errorCanvas.getGraphics();
            Integer trainErrorRate = new Integer((int)((1.0-trainErrRate)*(r.height-16)));
            Integer testErrorRate = new Integer((int)((1.0-testErrRate)*(r.height-16)));
            errVec.addElement(trainErrorRate);
            errVec.addElement(testErrorRate);
            int numIter=0;
            if (myClassifier instanceof LocBoost)
                numIter = ((LocBoost)myClassifier).m_NumIterations;
            else 
                numIter = ((LocBoost2)myClassifier).m_NumIterations;
            char[] numI;
            if (numIter!=0) {
                Point curPoint = new Point(0,0);
                Point curPoint2 = new Point(0,0);
                int interval = (int)(r.width*0.9/(1+numIter));
                int modFactor = 1+ (numIter/10);// for spacing of iterations
                for (int i=0 ;i<errVec.size(); i+=2) {
                    Integer cur = (Integer)errVec.elementAt(i);
                    int newp = curPoint.x+interval;
                    g.setColor(new Color(128,0,255));
                    g.drawLine(curPoint.x, curPoint.y, newp, cur.intValue());
                    g.drawLine(curPoint.x, curPoint.y-1, newp, cur.intValue()-1);
                    curPoint.x = newp;
                    curPoint.y = cur.intValue();
                    
                    cur = (Integer)errVec.elementAt(i+1);
                    newp = curPoint2.x+interval;
                    g.setColor(new Color(0,128,0));                    
                    g.drawLine(curPoint2.x, curPoint2.y, newp, cur.intValue());
                    g.drawLine(curPoint2.x, curPoint2.y-1, newp, cur.intValue()-1);
                    curPoint2.x = newp;
                    curPoint2.y = cur.intValue();
                    
                    if ((i/2)%modFactor==0) {
                        numI = String.valueOf(i/2).toCharArray();
                        g.setColor(Color.black);                 
                        g.drawChars(numI, 0, numI.length, curPoint.x, r.height-1);
                    }
                }
            }
            double rd,xd,yd;
	        if (myClassifier instanceof LocBoost) {
                 rd = ((LocBoost)myClassifier).m_RadiusOfUnknownGroup;
                 xd = ((LocBoost)myClassifier).m_CenterOfUnknownGroup[0]-rd;
                 yd = ((LocBoost)myClassifier).m_CenterOfUnknownGroup[1]-rd;
			} else {
                 rd = ((LocBoost2)myClassifier).m_RadiusOfUnknownGroup;
                 xd = ((LocBoost2)myClassifier).m_CenterOfUnknownGroup[0]-rd;
                 yd = ((LocBoost2)myClassifier).m_CenterOfUnknownGroup[1]-rd;
            }
            r = canvas.getBounds();        
            int x = (int)(r.width *(xd+0.5));
            int y = (int)(r.height*(yd+0.5));
            int size = (int)(r.width*rd*2);
            canvas.markUnknownRegion(x,y,size);
        }        
    }
    
	void initCanvas() {
	    Graphics g = errorCanvas.getGraphics();
	    int h = errorCanvas.getBounds().height;
	    int w = errorCanvas.getBounds().width;
	    g.clearRect(0, 0, w, h);
	    g.setColor(Color.gray);
	    for (int y=0; y<h; y+=h/5) 
	        g.drawLine(0, y, w, y);
	    labeTestlErr.setText("1.0");
	    labelTrainErr.setText("1.0");
	    labelIter.setText("");
	    prevErr.x = 2; prevErr.y = 0;
	}

	void singleRB_ItemStateChanged()
	{
        canvas.mode = 0;
        if (singleRB.getState()) {
            multipleRB.setState(false);
		}
	}

	void multipleRB_ItemStateChanged()
	{
        canvas.mode = 1;
        if (multipleRB.getState()) {
            singleRB.setState(false);
		}
	}

	void distribChoice_ItemStateChanged()
	{
	    boolean normal = (distribChoice.getSelectedIndex()==0);
        coverL.setVisible(!normal);
        coverTF.setVisible(!normal);
        percentL.setVisible(!normal);
        sigmaL.setVisible(normal);
        sigmaTF.setVisible(normal);
	}

	class MActionListener implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == clearB) {
			    canvas.resetPoints();
			    initCanvas();
			    boosterStarted = false;
                errVec.removeAllElements();
			} else if (object ==pB) {
			    if (drawThr_suspended) {
			        canvas.drawThr.resume();
			        pB.setLabel("Stop Drawing");
			    } else {
			        canvas.drawThr.suspend();
			        pB.setLabel("Resume");
			    }
			    drawThr_suspended = !drawThr_suspended;
			}
			else if (object == step) {
			    iterateBooster(1);				
			}
			else if (object == stepN) {
			    int n = Integer.valueOf(numIterTF.getText()).intValue();
			    iterateBooster(n);	
			}
			else if (object == classifyB) {
			    popup.setVisible(false);
			    myClassify();
			}
			else if (object == resetB) {
			    canvas.displayBoundaries = false;
			    initCanvas();
			    boosterStarted = false;
                errVec.removeAllElements();
			    canvas.DrawAllFlag = true;
                canvas.repaint();			    
			}
			else if (object == viewArffB) {
			    if (canvas.ARFF_PARSED==false) canvas.parseInstances();
			    canvas.aFrame = new ArffFrame();
			    canvas.aFrame.textArea.setText(canvas.trainInstances.toString());
			    canvas.aFrame.setVisible(true);
			    canvas.DrawAllFlag = true;
			}
			else if (object == reportB) {
			    canvas.rFrame = new ArffFrame("Classifier Information");
			    canvas.rFrame.textArea.setText(myClassifier.toString());
			    canvas.rFrame.setVisible(true);
			}
			else if (object == refreshB)
				canvas.repaint();
			else if (object == saveB) 
			    canvas.saveData();
			else if (object == loadB) 
			    canvas.loadData();
			else if (object == splitB)
				canvas.splitData(Integer.parseInt(dataPercentTF.getText()));
			else if (object == helpB) {
                try {			    
			        URL help = new java.net.URL(getCodeBase() +  "Help/main.html");
			        getAppletContext().showDocument(help, "_blank");
                } catch (java.net.MalformedURLException e) { e.printStackTrace(); }
			} else if (object == undoB)
			    canvas.undo();
		}
	}

	class MTextListener implements java.awt.event.TextListener
	{
		public void textValueChanged(java.awt.event.TextEvent event)
		{
			Object object = event.getSource();
			if (object == dataPercentTF) {
				canvas.ARFF_PARSED = false;
			}
		}
	}

    private void iterateBooster(int n) {
        msgLabel.setText("Classifying");
        if (boosterStarted==false)
            myClassify();
	    if (myClassifier instanceof LocBoost) {
        for (int i=0; i<n; i++) {
    		((LocBoost)myClassifier).m_NumIterations++;
	    	if (((LocBoost)myClassifier).iterate()==false) {
                msgLabel.setText("Training set is correctly classified!");
                return;
            }
    		updateErrGraph();    		
			labelIter.setText(String.valueOf(((LocBoost)myClassifier).m_NumIterations));
			canvas.repaint();
	    }
		} else if (myClassifier instanceof LocBoost2) {
            for (int i=0; i<n; i++) {
    		    ((LocBoost2)myClassifier).m_NumIterations++;
	    	    if (((LocBoost2)myClassifier).iterate()==false) {
                    msgLabel.setText("Training set is correctly classified!");
                    return;
                }
    		    updateErrGraph();    		
			    labelIter.setText(String.valueOf(((LocBoost2)myClassifier).m_NumIterations));
			    canvas.repaint();
	        }
	    }
        msgLabel.setText("");
    }
    
    private void myClassify() { 
		if (!canvas.ARFF_PARSED) {
			canvas.parseInstances();
			initCanvas();
		}
		try {
		    if (myClassifier instanceof AdaBoostM1) {
		        ((AdaBoostM1)myBooster).setMaxIterations(Integer.valueOf(adaIterTF.getText()).intValue());
		    } else if (myClassifier instanceof SMO) {
		        ((SMO)myClassifier).setC(Double.valueOf(complexTF.getText()).doubleValue());
		        ((SMO)myClassifier).setExponent(Double.valueOf(kernelTF.getText()).doubleValue());		        
		    } else if (myClassifier instanceof IBk) {
		        ((IBk)myClassifier).setKNN(Integer.parseInt(KNNTF.getText()));
		    } else if (myClassifier instanceof LogitBoost) {
		        ((LogitBoost)myBooster).setMaxIterations(Integer.valueOf(adaIterTF.getText()).intValue());
		    } else if (myClassifier instanceof Bagging ) {
		        ((Bagging)myBooster).setNumIterations(Integer.valueOf(adaIterTF.getText()).intValue());
		    } else if (myClassifier instanceof RegressionByDiscretization) {
		    } else if (myClassifier instanceof weka.classifiers.j48.J48) {
		        ((weka.classifiers.j48.J48)myClassifier).setConfidenceFactor(Float.valueOf(cfTF.getText()).floatValue());
		        ((weka.classifiers.j48.J48)myClassifier).setNumFolds(Integer.valueOf(nfTF.getText()).intValue());
		        ((weka.classifiers.j48.J48)myClassifier).setUnpruned(pruneCB.getState());
		    } else if (myClassifier instanceof IBk) {
    	        ((IBk)myClassifier).setKNN(Integer.parseInt(KNNTF.getText()));            
		    }

            msgLabel.setText("Classifying ...");			        
			canvas.testInstances.setClassIndex(2) ;
			canvas.trainInstances.setClassIndex(2) ;
			myClassifier.buildClassifier(canvas.trainInstances);
            updateErrGraph();
            canvas.inst.setDataset(canvas.trainInstances);
            boosterStarted = true;
		} catch (Exception e) {e.printStackTrace(); }
        msgLabel.setText("");
		canvas.displayBoundaries = true;
		canvas.repaint();
		if (myClassifier instanceof LocBoost)
		    labelIter.setText(String.valueOf(((LocBoost)myClassifier).m_NumIterations));
		if (myClassifier instanceof LocBoost2)
		    labelIter.setText(String.valueOf(((LocBoost2)myClassifier).m_NumIterations));
	}

    private void setClassifierGUI() {
        boolean loc=false;
        boolean loc2=false;
        boolean ada=false;
        boolean smo=false;
        boolean ibk=false;
        boolean j48=false;
        boolean other=false;
        if (myClassifier instanceof LocBoost) {
            loc=true;
            optimTF.setText(String.valueOf(((LocBoost)myClassifier).getOptimSteps()));
            ((LocBoost)myClassifier).setOptimization(genCB1.getState());
            ((LocBoost)myClassifier).setOverfitting(genCB2.getState());
            genCB1.setState(((LocBoost)myClassifier).getOptimization());
            genCB2.setState(((LocBoost)myClassifier).getOverfitting());
        } else if (myClassifier instanceof LocBoost2) {
            loc=true;
            loc2=true;
            optimTF.setText(String.valueOf(((LocBoost2)myClassifier).getOptimSteps()));
            ((LocBoost2)myClassifier).setOptimization(genCB1.getState());
            ((LocBoost2)myClassifier).setOverfitting(genCB2.getState());
            genCB1.setState(((LocBoost2)myClassifier).getOptimization());
            genCB2.setState(((LocBoost2)myClassifier).getOverfitting());
        } else if (myClassifier instanceof AdaBoostM1) {
            ada=true;
        } else if (myClassifier instanceof SMO) {
            smo=true;
        } else if (myClassifier instanceof IBk) {
            ibk=true;
        } else if (myClassifier instanceof RegressionByDiscretization) {
            ada=true;
        } else if (myClassifier instanceof Bagging) {
            ada=true;
        } else if (myClassifier instanceof ClassificationViaRegression) {
            ada=true;
        } else if (myClassifier instanceof LogitBoost) {
            ada=true;
        } else if (myClassifier instanceof weka.classifiers.j48.J48) {
            j48=true;
        } else {
            other=true;
        }        

        KNNTF.setVisible(ibk);
        labelKNN.setVisible(ibk);
        classifyB.setVisible(!loc);
        step.setVisible(loc);
        stepN.setVisible(loc);
        errorCanvas.setVisible(loc);
        numIterTF.setVisible(loc);
        inLabel.setVisible(loc);
        labelIter.setVisible(loc);
        genCB1.setVisible(loc);
        genCB2.setVisible(loc);
        label14.setVisible(loc);
        label15.setVisible(loc);
        label16.setVisible(loc);
        label18.setVisible((loc||ada)&&(!loc2));
        label19.setVisible(loc);
        baseChoice.setVisible((loc||ada)&&(!loc2));
        optimTF.setVisible(loc);
        labelAda.setVisible(ada);
        adaIterTF.setVisible(ada);
        labelC.setVisible(smo);
        labelKernel.setVisible(smo);
        complexTF.setVisible(smo);
        labelCF.setVisible(j48);
        cfTF.setVisible(j48);
        labelNF.setVisible(j48);
        nfTF.setVisible(j48);
        pruneCB.setVisible(j48);
        kernelTF.setVisible(smo);
        baseChoice.removeAll();
        if (myClassifier instanceof LogitBoost) {
		    baseChoice.addItem("Decision Stump");
		    baseChoice.addItem("Decision Table");
        } else {
		    baseChoice.addItem("C4.5");
		    baseChoice.addItem("Decision Stump");
		    baseChoice.addItem("Decision Table");
		    baseChoice.addItem("1-Nearest Neighbor");
		    baseChoice.addItem("Logistic");
		    baseChoice.addItem("Naive Bayes");
		    baseChoice.addItem("Voted Perceptron");
		    baseChoice.addItem("ZeroR");
		}
		int idx = (myClassifier instanceof LogitBoost)?0:4;
		try {
			baseChoice.select(idx);
		} catch (IllegalArgumentException e) { }
    }

    private void selectClassifier(int clsf) {        
	    switch (clsf) {
	        case 6: myClassifier = new LocBoost();
	                boosterStarted = false;
                    ((LocBoost)myClassifier).setMaxIterations(0);
                    errVec.removeAllElements();
	                baseChoice_ItemStateChanged();
	        break;
	        case 7: myClassifier = new LocBoost2(); 
	                boosterStarted = false;
                    ((LocBoost2)myClassifier).setMaxIterations(0);
                    errVec.removeAllElements();
	        break;
	        case 0: myBooster = new AdaBoostM1();
	                myClassifier = myBooster;
	                baseChoice_ItemStateChanged();
	        break;
	        case 9: myBooster = new LogitBoost();
	                myClassifier = myBooster;
	                baseChoice_ItemStateChanged();
	        break;
	        case 1: myBooster = new Bagging();
	                myClassifier = myBooster;
	                baseChoice_ItemStateChanged();
	        break;
	        case 11: myBooster = new ClassificationViaRegression();
	                myClassifier = myBooster;
	                baseChoice_ItemStateChanged();
	        break;
	        case 12: myClassifier = new SMO();
	                baseChoice_ItemStateChanged();
	        break;
	        case 13: myClassifier = new KernelDensity(); 
	        break;
	        case 5: myClassifier = new IBk();
	        break;
	        case 2: myClassifier = new weka.classifiers.j48.J48(); 
	        break;
	        case 8: myClassifier = new Logistic();
	        break;
	        case 10: myClassifier = new NaiveBayes(); 
	        break;
	        case 3: myClassifier = new DecisionStump(); 
	        break;
	        case 4: myClassifier = new DecisionTable(); 
	        break;
 	    }
 	}

    protected class ToolTipThread extends Thread {
        
        Object m_obj;
        
        public void setObject(Object obj) {
            m_obj = obj;
        }

        public void run () {
            showToolTip = true;
            Point position = ((Component)m_obj).getLocation();
            Rectangle r = ((Component)m_obj).getBounds();
            String str = " ";
            if (m_obj==classifyB) {
                str = " Perform Classification";
            } else if (m_obj==helpB) {
                str = " Online Help";
            } else if (m_obj==step) {
                str = " Make one boosting step";
            } else if (m_obj==stepN) {
                str = " Make a few boosting steps";
            } else if (m_obj==resetB) {
                str = " Reset the classifier";
            } else if (m_obj==clearB) {
                str = " Remove all instances";
            } else if (m_obj==loadB) {
                str = " Read a predefined dataset";
            } else if (m_obj==saveB) {
                str = " Save the dataset (only when run locally)";
            } else if (m_obj==classifierChoice) {
                str = " Select classifier";
            } else if (m_obj==baseChoice) {
                str = " Base classifier for boosting";
            } else if (m_obj==viewArffB) {
                str = " Textual representation of dataset";
            } else if (m_obj==reportB) {
                str = " Details about current classifier";
            } else if (m_obj==refreshB) {
                str = " Redraw the area";
            } else if (m_obj==gradientCB) {
                str = " Represent confidence by gradient colors";
            } else if (m_obj==instApprCB) {
                str = " Control points size";
            } else if (m_obj==splitB) {
                str = " Split to train/test sets";
            } else if (m_obj==undoB) {
                str = " Undo last point(s) addition";
            } else if (m_obj==smoothingCB) {
                str = " Increase resolution where classification changes";
            }
            int size = str.length()*6;
		    popup.setBounds(position.x,position.y+r.height,size,16);
            try { Thread.sleep(1500); } catch (Exception e) {}
            if (!showToolTip) {
                return;
            }
            popup.setVisible(true);
            popup.getGraphics().clearRect(0,0,popup.getBounds().width-1,popup.getBounds().height-1);
            popup.getGraphics().drawString(str, 0, 12);
            popup.getGraphics().drawRect(0,0,popup.getBounds().width-1,popup.getBounds().height-1);
            try {
                while (toolTipCount<8) {
                    Thread.sleep(1200);
                    toolTipCount++;
                }
            } catch (Exception e) {}
            popup.setVisible(false);
            return;
        }
    }

	class MMouse extends java.awt.event.MouseAdapter
	{
		public void mouseEntered(java.awt.event.MouseEvent event)
		{
		    toolTipThr = new ToolTipThread();
            toolTipThr.setPriority(Thread.MIN_PRIORITY);
			Object object = event.getSource();
            toolTipCount=0;
            toolTipThr.setObject(object);
            toolTipThr.start();
        }

		public void mouseExited(java.awt.event.MouseEvent event)
		{
           popup.setVisible(false);
           showToolTip = false;
		}
	}


	class MMouseMotion extends java.awt.event.MouseMotionAdapter
	{
		public void mouseMoved(java.awt.event.MouseEvent event)
		{
            if (toolTipCount>4) {
                popup.setVisible(false);
                showToolTip = false;
                return;
            }
		}
	}
}
