/*
 *    Linef.java
 *    Copyright (C) 2000 Gilad Mishne
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *  
 *
 * @author Gilad Mishne (gilad.mishne@intel.com)
 * @version $Revision: 1.0 $ 
 */
 
 package weka.optimization;
 import weka.optimization.*;
 
public class Linef implements MinSingleVarFuncInterface {
    MinFuncInterface fnClass = null;
    double[] x = null;
    double[] d = null;
    int n = -1;
        
    public void setFunc(MinFuncInterface fn) { fnClass = fn; }
    public void setX(double[] X) { x=X; }
    public void setD(double[] D) { d=D; }
    public void setN(int N) { n=N; }
        
    public double f(double lambda) {
        return (fnClass.f(ArrUtils.arr_plus(ArrUtils.arr_mul(d,lambda),x)));
        // the original says X+LAMBDA*D so maybe need to replace mul and plus            
    }
                
}
